#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_Constant_1" type="Constant" x="-565.000000" y="13.000000">
      <Parameter name="VALUE" type="subnet_param" value="string:ARG1" description="The value"/>
    </Node>
    <Node name="node_InputStream_1" type="InputStream" x="-449.000000" y="13.000000">
      <Parameter name="TYPE" type="String" value="" description="Type of stream: stream, fd, or FILE (default stream)"/>
      <Parameter name="RETRY" type="int" value="" description="If set to N, InputStream will retry N times on open fail"/>
    </Node>
    <Node name="node_LOOP_1" type="LOOP" x="-351.000000" y="13.000000">
      <Parameter name="int:LENGTH" type="int" value="512" description="No Description Available"/>
      <Parameter name="int:NUM_CHANNEL" type="int" value="8" description="No Description Available."/>
      <Parameter name="string:BASENAME" type="subnet_param" value="string:ARG2" description="Basename of files. [default: sep_]"/>
      <Parameter name="DOWHILE" type="bool" value="" description=""/>
    </Node>
    <Link from="node_Constant_1" output="VALUE" to="node_InputStream_1" input="INPUT"/>
    <Link from="node_InputStream_1" output="OUTPUT" to="node_LOOP_1" input="INPUT"/>
    <NetOutput name="OUTPUT" node="node_LOOP_1" terminal="OUTPUT" object_type="Map&lt;int,ObjectRef&gt;" description="The same as input."/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Network type="iterator" name="LOOP">
    <Node name="node_AudioStreamFromWave_1" type="AudioStreamFromWave" x="-887.000000" y="-176.000000">
      <Parameter name="LENGTH" type="subnet_param" value="int:LENGTH" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="USE_WAIT" type="bool" value="false" description="If true, real recording is simulated [default: false]."/>
    </Node>
    <Node name="node_MultiFFT_1" type="MultiFFT" x="-614.000000" y="-183.000000">
      <Parameter name="LENGTH" type="int" value="512" description="FFT length in sample. [default: 512]"/>
      <Parameter name="WINDOW" type="string" value="HAMMING" description="A window function for FFT. WINDOW should be CONJ, HAMMING, RECTANGLE, or HANNING. [default: CONJ]"/>
      <Parameter name="WINDOW_LENGTH" type="int" value="512" description="Window length of the window function. [default: 512]"/>
    </Node>
    <Node name="node_MultiRobustPCA_1" type="MultiRobustPCA" x="-493.000000" y="-183.000000">
      <Parameter name="NUM_CHANNEL" type="subnet_param" value="int:NUM_CHANNEL" description="No Description Available"/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="No Description Available"/>
      <Parameter name="LENGTH" type="subnet_param" value="int:LENGTH" description="No Description Available"/>
      <Parameter name="CUTOFF_FREQ" type="float" value="125" description="No Description Available"/>
      <Parameter name="MAX_LANK" type="int" value="100" description="No Description Available"/>
      <Parameter name="GLOBAL_SCALE" type="float" value="5e-2" description="No Description Available"/>
      <Parameter name="SCALE_UPDATE_RATIO" type="float" value="0.01" description="No Description Available"/>
      <Parameter name="LAMBDA" type="float" value="1e-1" description="No Description Available"/>
      <Parameter name="EPSILON" type="float" value="1e-3" description="No Description Available"/>
    </Node>
    <Node name="node_MedianIntegrator_1" type="MedianIntegrator" x="-299.000000" y="-191.000000">
      <Parameter name="NUM_CHANNEL" type="subnet_param" value="int:NUM_CHANNEL" description="No Description Available."/>
      <Parameter name="LENGTH" type="subnet_param" value="int:LENGTH" description="No Description Available"/>
    </Node>
    <Node name="node_SAVE_WAVE_1" type="SAVE_WAVE" x="-172.000000" y="-191.000000">
      <Parameter name="string:BASENAME" type="subnet_param" value="string:BASENAME" description="Basename of files. [default: sep_]"/>
    </Node>
    <Link from="node_AudioStreamFromWave_1" output="AUDIO" to="node_MultiFFT_1" input="INPUT"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_MultiRobustPCA_1" input="INPUT"/>
    <Link from="node_MultiRobustPCA_1" output="OUTPUT" to="node_MedianIntegrator_1" input="SPARSE"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_MedianIntegrator_1" input="SPEC">-581.5 -183 -550 -199 -411.5 -198.5 </Link>
    <Link from="node_MedianIntegrator_1" output="OUTPUT" to="node_SAVE_WAVE_1" input="INPUT"/>
    <NetCondition name="CONDITION" node="node_AudioStreamFromWave_1" terminal="NOT_EOF"/>
    <NetInput name="INPUT" node="node_AudioStreamFromWave_1" terminal="INPUT" object_type="Stream" description="An audio input stream (IStream)."/>
    <NetOutput name="OUTPUT" node="node_SAVE_WAVE_1" terminal="OUTPUT" object_type="Map&lt;int,ObjectRef&gt;" description="The same as input."/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Network type="subnet" name="SAVE_WAVE">
    <Node name="node_SaveWavePCM_1" type="SaveWavePCM" x="190.000000" y="-507.000000">
      <Parameter name="BASENAME" type="subnet_param" value="string:BASENAME" description="Basename of files. [default: sep_]"/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (in samples)[default: 16000]."/>
      <Parameter name="BITS" type="string" value="int24" description="Bit format of samples. int16 , int24 and float32 bits are supported."/>
    </Node>
    <Node name="node_Synthesize_1" type="Synthesize" x="-59.000000" y="-507.000000">
      <Parameter name="LENGTH" type="int" value="512" description="Size of window length in sample. [default: 512]"/>
      <Parameter name="ADVANCE" type="int" value="160" description="The length in sample between a frame and a previous frame. [default: 160]"/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="125" description="Minimum frequency (Hz) [default: 125]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="7900" description="Maximum frequency (Hz) [default: 7900]"/>
      <Parameter name="WINDOW" type="string" value="HAMMING" description="A window function for overlap-add. WINDOW should be CONJ, HAMMING, RECTANGLE, or HANNING. [default: HAMMING]"/>
      <Parameter name="OUTPUT_GAIN" type="float" value="256" description="Output gain factor. [default: 1.0]"/>
    </Node>
    <Node name="node_MatrixToMap_1" type="MatrixToMap" x="-167.000000" y="-507.000000"/>
    <Node name="node_PyCodeExecutor_1" type="PyCodeExecutor" x="62.000000" y="-507.000000">
      <Parameter name="DIRECTORY_NAME" type="string" value="./" description="The directory name of your python code. It will inserted to sys.path."/>
      <Parameter name="MODULENAME" type="string" value="map_to_matrix" description="Your python module name to import, i.e., your python code file name WITHOUT extension."/>
      <Parameter name="CLASSNAME" type="string" value="MapToMatrix" description="Your class name to call in this node."/>
      <Parameter name="DEBUG" type="bool" value="false" description="Debug option. If true, it prints input list and output list."/>
    </Node>
    <Link from="node_PyCodeExecutor_1" output="OUTPUT" to="node_SaveWavePCM_1" input="INPUT"/>
    <Link from="node_MatrixToMap_1" output="OUTPUT" to="node_Synthesize_1" input="INPUT"/>
    <Link from="node_Synthesize_1" output="OUTPUT" to="node_PyCodeExecutor_1" input="INPUT"/>
    <NetOutput name="OUTPUT" node="node_SaveWavePCM_1" terminal="OUTPUT" object_type="Map&lt;int,ObjectRef&gt;" description="The same as input."/>
    <NetInput name="INPUT" node="node_MatrixToMap_1" terminal="INPUT" object_type="any" description="A matrix of complex float or float."/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Parameter name="string:ARG1" type="" value=""/>
  <Parameter name="string:ARG2" type="" value=""/>
</Document>
